/* Copyright (c) 2011-2017, NVIDIA CORPORATION. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *  * Neither the name of NVIDIA CORPORATION nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;


template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, amgx::Vector<amgx::TemplateConfig<(AMGX_MemorySpace)1, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;


//More:
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDouble, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matFloat, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matDoubleComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo1Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3Functor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)8, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecInt, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDoubleComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecFloat, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo2AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
template struct ExcHalo3AsyncFunctor<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecComplex, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt>, class amgx::Vector<struct amgx::TemplateConfig<(AMGX_MemorySpace)0, (AMGX_VecPrecision)AMGX_vecDouble, (AMGX_MatPrecision)AMGX_matComplex, (AMGX_IndPrecision)AMGX_indInt> > >;
